#ifndef _BUF_H
#define _BUF_H

/* line buffer callback */
typedef void (* lnproc_t) (char *line, char *endline, void *data);

/* line buffer */
typedef struct lnbuf lnbuf_t;
struct lnbuf {
	int len;
	int alloc;
	char *data;

	void *cbdata;
	lnproc_t callback;
};

void lnbuf_write(lnbuf_t *l, char *d, int n);
void lnbuf_init(lnbuf_t *l, lnproc_t callback, void *cbdata);

/* simple grow buffer */
typedef struct {
	int alloc;
	char *buf;  /* beginning */
	char *cur;  /* read cursor */
	char *data; /* write cursor */
} growbuf_t;

/* initialize growbuf */
void growbuf_init(growbuf_t *b);

/* ensures there is enough space after b->data
 * you have to move b->data yourself */
void growbuf_alloc(growbuf_t *b, int amt);

/* moves b->data */
void growbuf_consume(growbuf_t *b, int amt);

/* writes some data into a growbuf */
void growbuf_write(growbuf_t *b, void *data, int len);

/* is growbuf nonempty? */
int growbuf_hasdata(growbuf_t *b);

#endif
